
#include <Adafruit_NeoPixel.h>

#define VOLTMETER       A0
#define RELAIS          13
#define LEDPIN          6
#define NUMPIXELS       250
#define HALLSENSOR      A5

Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, LEDPIN, NEO_GRB + NEO_KHZ800);

int hallValues[NUMPIXELS];

void setup() {
  pinMode(RELAIS, OUTPUT);
  Serial.begin(9600);
  pixels.begin();




  for (int i = 0; i < NUMPIXELS; i++) {
    pixels.setPixelColor(i, pixels.Color(0, 0, 0));
  }
  pixels.show();


}

void loop() {


  // ------------------------------------------------------ Überspannungsschutz
  int voltage = map(analogRead(VOLTMETER), 0, 1023, 0, 55);
  //Serial.println(voltage);
  if (voltage > 11) {
    digitalWrite(RELAIS, HIGH);
    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(0, 0, 0));
    }
    pixels.show();
    delay(30000);
    digitalWrite(RELAIS, LOW);
  }


  // ------------------------------------------------------ read  hall sensor
  int hall = analogRead(HALLSENSOR);
  Serial.print(hall);
  Serial.println(",0,1023");

  hallValues[0]  = hall;
  for (int i = NUMPIXELS - 1; i >= 1; i--) { // ring buffer
    hallValues[i] = hallValues[i - 1];
  }


  // ------------------------------------------------------ LED's
  float t = millis();
  float blue = (sin(t / 500) + 1) * 10;

  for (int i = 0; i < NUMPIXELS; i++) {
    int tmpHall;

    if (hallValues[i] > 524) {
      tmpHall = hallValues[i] - 524;
      float   multi = 25 - constrain(tmpHall, 0, 25);
      multi = multi / 25;
      tmpHall = constrain(tmpHall, 2, 25);
      tmpHall = (tmpHall - 2) * 4;
      pixels.setPixelColor(i, pixels.Color(tmpHall * 2, tmpHall * .05, blue * multi));
    } else {
      tmpHall = 524 - hallValues[i];
      float   multi = 25 - constrain(tmpHall, 0, 25);
      multi = multi / 25;
      tmpHall = constrain(tmpHall, 2, 25);
      tmpHall = (tmpHall - 2) * 4;
      pixels.setPixelColor(i, pixels.Color(tmpHall * .8, tmpHall * 1.5, blue * multi));
    }
  }


  pixels.show(); // This sends the updated pixel color to the hardware.



}
